var createError = require("http-errors");
var express = require("express");
var mongoose = require("mongoose");
var path = require("path");
var cookieParser = require("cookie-parser");
var bodyParser = require("body-parser");
var logger = require("morgan");
var session = require("express-session");
var FileStore = require("session-file-store")(session);

var bookRouter = require("./routes/books");
var loginRouter = require("./routes/login");
var emailRouter = require("./routes/emails");

var app = express();

mongoose.Promise = global.Promise;

var mongoDB = "mongodb+srv://dragonash:team202@cluster0-sgfno.mongodb.net/test";

var promise = mongoose.connect(mongoDB, {
  useMongoClient: true
});
//mongoose.connect(mongoDB);

app.use(
  session({
    secret: "!@#$MySESSION$#@!",
    resave: false,
    saveUninitialized: true,
    store: new FileStore()
  })
);

app.use(require("connect-history-api-fallback")());

// view engine setup
app.set("views", path.join(__dirname, "views"));
app.set("view engine", "pug");

app.use(logger("dev"));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, "public")));

app.use("/api/books", bookRouter);
app.use("/api/login", loginRouter);
app.use("/api/emails", emailRouter);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get("env") === "development" ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render("error");
});

module.exports = app;
